#ifndef _XCTYPES_H
#define _XCTYPES_H

#define OP_NOP 0
#define OP_LD_RR 1
#define OP_LD_RC 5
#define OP_LD_RMC 9
#define OP_LD_RMR 13
#define OP_LD_RHC 17
#define OP_LD_RHR 21
#define OP_LD_MCR 25
#define OP_LD_MRR 29
#define OP_LD_HCR 33
#define OP_LD_HRR 37
#define OP_ADD 41
#define OP_FADD 45
#define OP_SUB 49
#define OP_FSUB 53
#define OP_MULT 57
#define OP_MULTS 61
#define OP_FMULT 65
#define OP_TEST 69
#define OP_DIV 73
#define OP_DIVS 77
#define OP_FDIV 81
#define OP_FCP 85
#define OP_MOD 89
#define OP_MODS 93
#define OP_SL 97
#define OP_SLN 101
#define OP_SR 105
#define OP_SRN 109
#define OP_NEG 113
#define OP_FNEG 117
#define OP_OR 121
#define OP_AND 125
#define OP_NOT 129
#define OP_XOR 133
#define OP_BOR 137
#define OP_BAND 141
#define OP_BNOT 145
#define OP_CP 149
#define OP_JP 153
#define OP_JP_Z 154
#define OP_JP_NZ 155
#define OP_JP_C 156
#define OP_JP_NC 157
#define OP_CALL_C 158
#define OP_CALL_R 159
#define OP_RET 160
#define OP_RETV 161
#define OP_HCALL_C 165
#define OP_HCALL_R 166
#define OP_INC 167
#define OP_DEC 171
#define OP_PUSH 175
#define OP_POP 179
#define OP_JP_R 183
#define OP_JP_R_Z 184
#define OP_JP_R_NZ 185
#define OP_JP_R_C 186
#define OP_JP_R_NC 187
#define OP_ARG_C 188
#define OP_ARG_R 192
#define OP_HCPY 196
#define OP_HSCPY 197
#define OP_MCPY 198
#define OP_CPY 199
#define OP_SCPY 200
#define OP_DCPY 201
#define OP_PMODE 202
#define OP_IMODE 203
#define OP_RMODE 204
#define OP_OMODE 205
#define OP_EMODE 206
#define OP_SYNC 207
#define OP_RSEND 208
#define OP_MSEND 209
#define OP_MBASE 210
#define OP_MALLOC 211
#define OP_FREE 212
#define OP_LALLOC 213
#define OP_LFREE 214
#define OP_LADDR 215
#define OP_SCP 216
#define OP_STEST 220
#define OP_SLEN 224
#define OP_CAST 228
#define OP_FINC 229
#define OP_FDEC 233
#define OP_GBF 237
#define OP_SBF 238
#define OP_SGBF 239
#define OP_SSBF 240
#define OP_ZERO 241
#define OP_PING 242
#define OP_PONG 243
#define N_OPS 244

#define N_REG 16
#define S_REG 8
#define N_HOSTSYM 65535
#define S_NBUF 255

#define TRANS_NONE 0
#define TRANS_SEND 1
#define TRANS_RECV 2
#define TRANS_MAX 255

#define XC_LOCAL 0
#define XC_STREAMED 1
#define XC_ALTER 2

typedef struct datat
{
	unsigned char *dat;
	int sz;
} datat;

struct xc
{
	unsigned char *code, *code_end;
	datat *data;
	int n_data, mode, sz;
};

typedef struct memblock
{
	struct memblock *next, *prev;
	int min, max;
} memblock;

typedef struct lint
{
	struct lint *next, *prev;
	int n;
} lint;

typedef struct pstack
{
	struct pstack *next;
	char *ptr;
} pstack;

typedef struct stackt
{
	struct stackt *next;
	unsigned char n[S_REG];
} stackt;

typedef struct stack8
{
	struct stack8 *next;
	unsigned char n;
} stack8;

struct xinst
{
	struct xinst *next, *prev, *wnext, *wprev;
	xc *parent;
	xnet *in, *out, *serv;
	unsigned char *code, *code_end, *cp, *mem, reg[N_REG][S_REG];
	unsigned char *s_code, *s_code_end, *s_cp;
	unsigned char z, c, priority;
	lint *atex;
	stackt *stack;
	pstack *cstack;
	_int64 *arg;
	stack8 *cmode;
	unsigned char mode;
	unsigned char nbuf[S_NBUF];
	unsigned int memsz;
	int narg, marg, nbufp, nstat;
	unsigned char *transp;
	int transz, tmode, sz;
	memblock *mb_base, *cur_mb;
	lint *local;
	void (*callback)(void *), *callback_arg;
	_int32 ivars[XC_NUM_IVARS];
	void *tag;
};

typedef struct hostsymt
{
	unsigned char type;
	void *ptr;
	int sz;
} hostsymt;

void read_int(unsigned char *str, int sn, _int64 *i);
void write_int(unsigned char *str, int sn, _int64 i);
void print_bin(char *str, int len);
void print_float(_int64 m, _int32 e, int ln);
int read_float(unsigned char *str, int ln, _int64 *m, _int32 *e);
void write_float(unsigned char *otp, _int64 m, _int32 e, int ln);

int __xc_malloc(xinst *, int);
void __xc_free(xinst *, int);

#endif